// DisplayView.cpp : implementation file
//

#include "stdafx.h"
#include "MDILayout.h"

#include "MDILayoutDoc.h"
#include "DisplayView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisplayView

IMPLEMENT_DYNCREATE(CDisplayView, CView)

BEGIN_MESSAGE_MAP(CDisplayView, CView)
	//{{AFX_MSG_MAP(CDisplayView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_MESSAGE(WM_SIZEPARENT, OnSizeParent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplayView construction/destruction

CDisplayView::CDisplayView()
{
	// TODO: add construction code here

}

CDisplayView::~CDisplayView()
{
}

BOOL CDisplayView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDisplayView drawing

void CDisplayView::OnDraw(CDC* pDC)
{
	CMDILayoutDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->m_csSubitemText[0].IsEmpty())
	{
		return;
	}
	/**** JohnCz ***/
	// draw text changed by list view
	CString csText;
	
	CFont *pFont = pDC->SelectObject(&m_Font);
	pDC->SetTextColor(RGB(0, 0, 255));
	
	csText.Format("Subitem 1: %s", pDoc->m_csSubitemText[0]);
	pDC->TextOut(10, 10, csText);

	csText.Format("Subitem 2: %s", pDoc->m_csSubitemText[1]);
	pDC->TextOut(10, 25, csText);

	pDC->SelectObject(pFont);

}

/////////////////////////////////////////////////////////////////////////////
// CDisplayView printing

BOOL CDisplayView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDisplayView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDisplayView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDisplayView diagnostics

#ifdef _DEBUG
void CDisplayView::AssertValid() const
{
	CView::AssertValid();
}

void CDisplayView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMDILayoutDoc* CDisplayView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDILayoutDoc)));
	return (CMDILayoutDoc*)m_pDocument;
}
#endif //_DEBUG

LRESULT CDisplayView::OnSizeParent(WPARAM wParam, LPARAM lParam)
{
	AFX_SIZEPARENTPARAMS* lpLayout = (AFX_SIZEPARENTPARAMS*)lParam;
	
	CRect rectClient(lpLayout->rect);
	/**** JohnCz ***/
	// this is view placed under the title, lpLayout rectangle of this view	is set in title view
	// adjust layout to position to the right
	rectClient.DeflateRect(lpLayout->sizeTotal.cx, 0, -lpLayout->sizeTotal.cx, 0);

	// reset layout for leftover main view
	lpLayout->rect.top -= lpLayout->sizeTotal.cy;
	lpLayout->sizeTotal = rectClient.Size();

	if (lpLayout->hDWP != NULL)
		AfxRepositionWindow(lpLayout, m_hWnd, &rectClient);
	
	return 0;
	
}

/////////////////////////////////////////////////////////////////////////////
// CDisplayView message handlers

void CDisplayView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	/**** JohnCz ***/
	// create font for drawing
	LOGFONT lf;
	::GetObject((HFONT)GetStockObject(DEFAULT_GUI_FONT), sizeof(lf), &lf);
	
	CClientDC dc(this);

	// weight and size
	lf.lfWeight = FW_BOLD;
	lf.lfHeight = -MulDiv(10, GetDeviceCaps(dc.m_hDC, LOGPIXELSY), 72);;
	
	m_Font.CreateFontIndirect(&lf);

	SetFont(&m_Font);
	
}

void CDisplayView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	/**** JohnCz ***/
	// force repainting
	Invalidate();
}
